
#include <iostream>
using namespace std;
#include <stack>

char Infix[] = "2 * 3 - 6 + 8 / 4";		//	ǥ.
char Postfix[256];						//	ǥ.

int main(void)
{
	stack<char> s;
	
	int Length = strlen(Infix);
	int count = 0;
	printf(" ǥ : %s\n\n", Infix);

	for (int i = 0; i < Length ; i++){
		char Data = Infix[i];

		switch(Data)
		{
		case '*':case '/':
			{
				if(s.empty()){
					s.push(Data);
					break;
				}

				if(s.top() == '*' || s.top() == '/'){
					Postfix[count++] = s.top();
					s.pop();
					Postfix[count++] = ' ';		//	 ߰
				}

				s.push(Data);
				break;
			}
		case '+':case '-':
			{
				while(!s.empty()){
					Postfix[count++] = s.top();
					s.pop();
					Postfix[count++] = ' ';		//	 ߰
				}

				s.push(Data);
				break;
			}
		default:
			{
				Postfix[count] = Data;
				count++;
				break;
			}
		}
	}

	Postfix[count++] = ' ';						//	 ߰

	while(!s.empty()){
		Postfix[count++] = s.top();
		Postfix[count++] = ' ';
		s.pop();
	}

	printf(" ǥ : %s\n", Postfix);

	return 0;
}
